
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include "rs232.h"


static int PORT = COM1;  /* Default */

uchar buf_in[1024], buf_out[1024];
/* Buffer for async receive/transmit */



int main(int argc, char* argv[])
{
   long t, t1;
   int  cnt;

   /* Pointer to the bios-ticker, increments 18.2 times per second */
   volatile long *biostick = (long *)((char*)_x386_zero_base_ptr + 0x0046c);

   if(argc > 1) {
     if(strcmpl(argv[1], "COM1")==0) PORT = COM1;
     else if(strcmpl(argv[1], "COM2")==0) PORT = COM2;
   }

   printf ("Test of RS-Interface in Symantec/Digital Mars and DOSX\n");
   printf ("Setting Port COM%d 300, no Parity, 8 Data, 1 Stop\n", PORT+1);
   rs_init (PORT, 300, 8, 1, PNO);
   printf ("Starting with Interrupted Read, INT write\n");
   rs_start (PORT, buf_in, sizeof(buf_in), buf_out, sizeof(buf_out));
   t = t1 = *biostick;

   while (!kbhit()) {
      int ch;
      cnt = 0;
      while((ch=rs_inchar(PORT)) >= 0) {
         /* got a byte from PORT */
         printf ("got 0x%02x (%c)\n", ch, ch);
         cnt++;
      }
      /* no more current chars */

      if (t1+182 < *biostick) {
         /* 10 seconds gone */
         printf ("--- sending long line ...");  fflush(stdout);
         rs_sendline (PORT, "\r\nA long line is comming over this interface"
                            " which will be spooled asynchronously\r\n"
                            "  This should still be transmitted when chars are"
                            " received from remote sites\r\n" );
         printf (" done\n");
         t1 = *biostick;
      }
   } /* while */
   getch();   /* consume ch */
   printf ("terminating ...");
   rs_stop(PORT);   /* disables own ISR */
   printf ("terminated!, returning now\n");
   return 0;
} /* main */


